<script lang="ts">
    import type { status as statusType } from "./../types/status"

    export let status: statusType

    const isEverythingAviable = (): boolean => {
        let everythingAviable = true
        status.forEach(entry => entry.down ? everythingAviable = false : null)

        return everythingAviable
    }
    const findOldestCheck = (): string => {
        let oldest: Date = null
        status.forEach(entry => {
            const date = new Date(entry.last_check_at)

            if(oldest == null) oldest = date
            else {
                if(date.getTime() <= oldest.getTime())
                    oldest = date
            }
        })

        return `${`0${oldest.getHours()}`.slice(-2)}:${`0${oldest.getMinutes()}`.slice(-2)}`
    }
</script>

<header>
    <h1>
        Status
    </h1>
    <h3>
        {#if isEverythingAviable()}
            Alle Systeme sind <span class="badge">online</span>
        {:else}
            Es kann zu Fehlern & Ausfällen kommen
        {/if}
        <i>({findOldestCheck()})</i>
    </h3>
    <p>
        Solltest du denoch Probleme haben melde dich beim <a href="https://homeworker.li/support">Kundendienst</a>. Wenn du einen Bug entdeckst, oder einen Vorschlag hast, melde dich auf <a href="https://gitlab.com/xolf/homeworker/-/issues/new">GitLab</a>
    </p>
</header>

<style>
    header {
        width: 90vw;
        max-width: 1000px;

        display: block;
        margin: auto;
    }

    h1 {
        margin-top: 100px;
        margin-bottom: 0px;

        font-weight: 500;
        font-size: 40px;
    }
    h3 {
        font-weight: 300;
        margin: 10px 0px;
    }
    i {
        color: var(--gray);

        font-size: 10px;
        font-weight: normal;
        font-style: italic;
        font-family: 'Roboto Mono', monospace;
    }

    p {
        margin: 0px;
        color: var(--gray);
    }
    a {
        color: var(--blue);
        text-decoration: none;
    }

    .badge {
        color: var(--background);
        background-color: var(--green);

        position: relative;
        top: -2px;

        font-size: smaller;
        font-weight: 600;

        padding: 3px 10px;
        border-radius: 15px;
    }
</style>